//L7Pb9
#include <stdio.h>
#include <stdlib.h>

int** aloca(int n)
{
    int **a=(int**)malloc(n*sizeof(int*));
    for (int i=0;i<n;i++)
        a[i]=(int*)calloc(n, sizeof(int)); // toate elementele sunt 0!!!!
    return a;
}

void citeste(int ***x, int *n)
{
    printf("n=");
    scanf("%d",n);
    *x = aloca(*n);
    for (int i=0; i<*n; i++)
        for (int j=0; j<*n; j++)
        {
            printf("Element[%d][%d]=",i,j);
            scanf("%d", &(*x)[i][j]);
        }
}

int** inmulteste(int**a, int n, int**b)
{
    int ** c= aloca(n);
    for (int i=0; i<n; i++)
        for (int j=0; j<n; j++)
            for (int k=0; k<n; k++)
                c[i][j] += a[i][k]*b[k][j];
    return c;
}

void copiaza(int **src, int n, int **dst)
{
    for (int i=0; i<n; i++)
        for (int j=0; j<n; j++)
            *(*(dst+i)+j)=src[i][j];
}

void afiseaza(int **x, int n)
{
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<n; j++)
            printf("%d ",x[i][j]);
        printf("\n");
    }
}

void dezaloca(int **, int);

int ** putere(int **a, int n, int k)
{
    int **r = aloca(n);
    for (int i=0; i<n; i++)
        r[i][i]=1; //diagonala principala 1

    for (int i=1; i<=k; i++)
    {
        int ** aux = inmulteste(r,n,a);
        copiaza(aux,n,r);
        dezaloca(aux,n);
    }
    return r;
}

void dezaloca(int **x, int n)
{
    for (int i=0; i<n; i++)
        free(x[i]);

    free(x);
}

int main()
{
    int n,k;
    int **a;
    citeste(&a,&n);
    printf("k=");
    scanf("%d",&k);
    int **b=putere(a,n,k);
    afiseaza(b,n);
    dezaloca(a,n);
    dezaloca(b,n);
    return 0;
}
