#include <stdio.h>
#include <stdlib.h>

int** aloca(int n)
{
    int **a=(int**)malloc(n*sizeof(int*));
    for (int i=0; i<n; i++)
        a[i]=(int*)malloc(n*sizeof(int));
    return a;
}

void citeste(int ***p, int *n)
{
    printf("n = ");
    scanf("%d", n);

    *p = aloca(*n);
    for(int i = 0; i < *n; i++)
    {
        for(int j = 0; j < *n; j++)
        {
            printf("a[%d][%d] = ", i, j);
            scanf("%d", (*p)[i] + j );
            // totuna cu &(*p)[i][j]
        }
    }

}
int** inmulteste(int** x, int n, int** y)
{
    int** z = aloca(n);
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            z[i][j] = 0;
            for(int k = 0; k < n; k++)
            {

                z[i][j] += x[i][k] * y[k][j];
            }
        }
    }
    return z;
}
void copiaza(int** a, int n, int** b)
{
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
        {
            b[i][j] = a[i][j];
        }
}
void dezaloca(int **a, int n){
    for(int i = 0; i < n; i++){
        free(a[i]);
    }
    free(a);
}

int** putere(int** a, int n, int k)
{
    int** rezultat = aloca(n);
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
            if(i == j)
                rezultat[i][j] = 1;
            else
                rezultat[i][j] = 0;
    }
    for(int i = 0; i < k; i++)
    {

        int** aux = inmulteste(rezultat, n, a);
        copiaza(aux, n, rezultat);
        dezaloca(aux, n);
    }
    return rezultat;
}
void afiseaza(int **a, int n){
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++)
            printf("%d ", a[i][j]); // totuna cu *(*(a + i) + j)
        printf("\n");
    }
}

int main()
{
    int **a;
    int n;
    int k;
    citeste(&a,&n);
    printf("k=");
    scanf("%d",&k);
    int **ak = putere(a,n,k);
    afiseaza(ak,n);
    dezaloca(a,n);
    dezaloca(ak,n);

    return 0;
}
