//L7Pb9
#include <stdio.h>
#include <stdlib.h>


int **aloca(int n){
    int **a=(int**)malloc(n*sizeof(int*));
    for (int i=0;i<n;i++)
            a[i]=(int*)malloc(n*sizeof(int));
    return a;
}
void citeste(int ***a,int *n){
    printf("n=");
    scanf("%d",n);
    *a=aloca(*n);
    for(int i=0;i<*n;i++){
        for(int j=0;j<*n;j++){
            printf("Element[%d][%d]=",i,j);
            scanf("%d",&(*a)[i][j]);   //(*a)[i]+j
        }
    }
}
void afiseaza(int **a,int n){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            printf("%d ",*(*(a+i)+j)); //a[i][j]
        }
        printf("\n");
    }
}
void dezaloca(int **a,int n){
    for(int i=0;i<n;i++){
        free(*(a+i));
    }
    free(a);
}
int **inmulteste(int **a,int **b,int n){
    int **rez=aloca(n);
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            rez[i][j]=0;
            for(int k=0;k<n;k++){
                rez[i][j]+=a[i][k]*b[k][j];
            }
        }
    }
    return rez;
}
void copiaza(int **dest,int **sur,int n){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            dest[i][j]=sur[i][j];
        }
    }

}
int** putere(int **a,int n,int k){
    int **r=aloca(n);
    //int **aux=aloca(n);
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(i==j){
                r[i][j]=1;
            }
            else r[i][j]=0;
        }
    }
    for(int i=0;i<k;i++){
        int **aux=inmulteste(r,a,n);
        copiaza(r,aux,n);
        dezaloca(aux,n);
    }
    return r;
}
int main()
{
    int **a;
    int n, k;
    citeste(&a,&n);
    printf("k=");
    scanf("%d",&k);
    int **r = putere(a,n,k);
    afiseaza(r,n);
    dezaloca(a,n);
    dezaloca(r,n);
    return 0;
}
