//L7Pb9
#include <stdio.h>
#include <stdlib.h>

int** aloca(int n) {
    int **a=(int**)malloc(n*sizeof(int*));
    for (int i=0;i<n;i++)
        a[i]=(int*)malloc(n*sizeof(int));

    return a;
}

void citeste(int ***x, int *n)
{
    printf("n=");
    scanf("%d", n);

    *x=aloca(*n);

    for (int i=0; i<*n; i++)
        for (int j=0; j<*n; j++)
        {
            printf("A[%d][%d]=",i,j);
            scanf("%d", (*x)[i]+j); // &(*x)[i][j]
        }
}

void afiseaza(int** x, int n)
{
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<n; j++)
            printf("%d ", x[i][j]); // *(*(x+i)+j)
        printf("\n");
    }
}

int ** inmulteste(int **x,int n,int **y)
{
    int **z = aloca(n);
    for (int i=0; i<n; i++)
        for (int j=0; j<n; j++)
        {
            z[i][j]=0;
            for (int k=0; k<n; k++)
                z[i][j] += x[i][k]*y[k][j];
        }
    return z;
}

void copiaza(int**dest, int n, int **src)
{
    for(int i=0; i<n; i++)
        for (int j=0; j<n; j++)
                dest[i][j]=src[i][j];
}

void dezaloca(int **a, int n)
{
    for (int i=0; i<n; i++)
        free(a[i]);

    free(a);
}

int ** putere(int **a, int n, int k)
{
    int **r = aloca(n);
    for(int i=0; i<n; i++)
        for (int j=0; j<n; j++)
            if (i==j)
                r[i][j]=1;
            else
                r[i][j]=0;

    for (int i=0; i<k; i++)
    {
        int ** aux = inmulteste(r,n,a);
        copiaza(r,n,aux);
        dezaloca(aux,n);
    }

    return r;
}

int main()
{
    int** a;
    int n, k;
    citeste(&a,&n);
    printf("k=");
    scanf("%d",&k);
    int **ak;
    ak=putere(a,n,k);
    afiseaza(ak,n);
    dezaloca(a,n);
    dezaloca(ak,n);
    return 0;
}
